src/main/java/entities/Images.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package entities;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author fred
 */
@Entity
@Table(name = "images")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Images.findAll", query = "SELECT i FROM Images i"),
    @NamedQuery(name = "Images.findById", query = "SELECT i FROM Images i WHERE i.id = :id"),
    @NamedQuery(name = "Images.findByFilename", query = "SELECT i FROM Images i WHERE i.filename = :filename")})
public class Images implements Serializable {

    @Lob
    @Column(name = "image")
    private byte[] image;

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Size(max = 45)
    @Column(name = "filename")
    private String filename;

    public Images() {
    }

    public Images(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }


    public String getFilename() {
        return filename;
    }

    public void setFilename(String filename) {
        this.filename = filename;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Images)) {
            return false;
        }
        Images other = (Images) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entities.Images[ id=" + id + " ]";
    }

    public byte[] getImage() {
        return image;
    }

    public void setImage(byte[] image) {
        this.image = image;
    }
    
}

src/main/java/jsfclasses/ImagesController.java
package jsfclasses;

import entities.Images;
import java.awt.Image;
import java.io.ByteArrayInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import jsfclasses.util.JsfUtil;
import jsfclasses.util.PaginationHelper;
import sessionbeans.ImagesFacade;

import java.io.Serializable;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.faces.model.SelectItem;
import javax.servlet.http.Part;
import org.apache.commons.io.FilenameUtils;
import org.apache.commons.io.IOUtils;

@Named("imagesController")
@SessionScoped
public class ImagesController implements Serializable {

    private Images current;
    private DataModel items = null;
    @EJB
    private sessionbeans.ImagesFacade ejbFacade;
    private PaginationHelper pagination;
    private int selectedItemIndex;
    private Part file;
    private String filename;
    private String extension;

    public ImagesController() {
    }

    public String submit() {
        current = new Images();
        getFacade().create(current);

        final String fileName = file.getName();
        InputStream filecontent;
        byte[] bytes = null;
        try {
            filecontent = getFile().getInputStream();
            int read = 0;

            // IOUtils.toByteArray(filecontent); // Apache commons IO.
            current.setImage(IOUtils.toByteArray(filecontent));

            //while ((read = filecontent.read(current.getImage())) != -1) {
//            }
            getFacade().edit(current);
        } catch (IOException ex) {
            Logger.getLogger(ImagesController.class.getName()).log(Level.SEVERE, null, ex);
        }
        filename = FilenameUtils.getBaseName(file.getSubmittedFileName());
        extension = FilenameUtils.getExtension(file.getSubmittedFileName());
        return "jsfUpload";
    }

    public byte[] getBytes() {
        byte[] b=new byte[0];
        if(current!=null){
            Images i = ejbFacade.find(current.getId());
            return i.getImage();
        }else
            return b;
    }

    public void test() {
        List<Images> list = ejbFacade.findAll();
        if (list.size() != 0) {
            current = list.get(0);
        }
        Path folder = Paths.get("/tmp");
        Path file2write = null;
        try {
            file2write = Files.createTempFile(folder, filename + "-", "." + extension);
        } catch (IOException ex) {
            Logger.getLogger(ImagesController.class.getName()).log(Level.SEVERE, null, ex);
        }

        InputStream input;
        try {
            OutputStream os = new FileOutputStream(file2write.toFile());
            ByteArrayInputStream in = new ByteArrayInputStream(current.getImage());
            IOUtils.copy(in, os);
            os.close();
            in.close();
//            input = file.getInputStream();
//            Files.copy(in, file2write, StandardCopyOption.REPLACE_EXISTING);
        } catch (IOException ex) {
            Logger.getLogger(ImagesController.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public Images getSelected() {
        if (current == null) {
            current = new Images();
            selectedItemIndex = -1;
        }
        return current;
    }

    private ImagesFacade getFacade() {
        return ejbFacade;
    }

    public PaginationHelper getPagination() {
        if (pagination == null) {
            pagination = new PaginationHelper(10) {

                @Override
                public int getItemsCount() {
                    return getFacade().count();
                }

                @Override
                public DataModel createPageDataModel() {
                    return new ListDataModel(getFacade().findRange(new int[]{getPageFirstItem(), getPageFirstItem() + getPageSize()}));
                }
            };
        }
        return pagination;
    }

    public String prepareList() {
        recreateModel();
        return "List";
    }

    public String prepareView() {
        current = (Images) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return "View";
    }

    public String prepareCreate() {
        current = new Images();
        selectedItemIndex = -1;
        return "Create";
    }

    public String create() {
        try {
            getFacade().create(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("ImagesCreated"));
            return prepareCreate();
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String prepareEdit() {
        current = (Images) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return "Edit";
    }

    public String update() {
        try {
            getFacade().edit(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("ImagesUpdated"));
            return "View";
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String destroy() {
        current = (Images) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        performDestroy();
        recreatePagination();
        recreateModel();
        return "List";
    }

    public String destroyAndView() {
        performDestroy();
        recreateModel();
        updateCurrentItem();
        if (selectedItemIndex >= 0) {
            return "View";
        } else {
            // all items were removed - go back to list
            recreateModel();
            return "List";
        }
    }

    private void performDestroy() {
        try {
            getFacade().remove(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("ImagesDeleted"));
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
        }
    }

    private void updateCurrentItem() {
        int count = getFacade().count();
        if (selectedItemIndex >= count) {
            // selected index cannot be bigger than number of items:
            selectedItemIndex = count - 1;
            // go to previous page if last page disappeared:
            if (pagination.getPageFirstItem() >= count) {
                pagination.previousPage();
            }
        }
        if (selectedItemIndex >= 0) {
            current = getFacade().findRange(new int[]{selectedItemIndex, selectedItemIndex + 1}).get(0);
        }
    }

    public DataModel getItems() {
        if (items == null) {
            items = getPagination().createPageDataModel();
        }
        return items;
    }

    private void recreateModel() {
        items = null;
    }

    private void recreatePagination() {
        pagination = null;
    }

    public String next() {
        getPagination().nextPage();
        recreateModel();
        return "List";
    }

    public String previous() {
        getPagination().previousPage();
        recreateModel();
        return "List";
    }

    public SelectItem[] getItemsAvailableSelectMany() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), false);
    }

    public SelectItem[] getItemsAvailableSelectOne() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), true);
    }

    public Images getImages(java.lang.Integer id) {
        return ejbFacade.find(id);
    }

    /**
     * @return the file
     */
    public Part getFile() {
        return file;
    }

    /**
     * @param file the file to set
     */
    public void setFile(Part file) {
        this.file = file;
    }

    /**
     * @return the filename
     */
    public String getFilename() {
        return filename;
    }

    /**
     * @param filename the filename to set
     */
    public void setFilename(String filename) {
        this.filename = filename;
    }

    /**
     * @return the extension
     */
    public String getExtension() {
        return extension;
    }

    /**
     * @param extension the extension to set
     */
    public void setExtension(String extension) {
        this.extension = extension;
    }

    @FacesConverter(forClass = Images.class)
    public static class ImagesControllerConverter implements Converter {

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            ImagesController controller = (ImagesController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "imagesController");
            return controller.getImages(getKey(value));
        }

        java.lang.Integer getKey(String value) {
            java.lang.Integer key;
            key = Integer.valueOf(value);
            return key;
        }

        String getStringKey(java.lang.Integer value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value);
            return sb.toString();
        }

        @Override

src/main/webapp/jsf/images/Create.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.CreateImagesTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.CreateImagesLabel_id}" for="id" />
                    <h:inputText id="id" value="#{imagesController.selected.id}" title="#{bundle.CreateImagesTitle_id}" required="true" requiredMessage="#{bundle.CreateImagesRequiredMessage_id}"/>
                    <h:outputLabel value="#{bundle.CreateImagesLabel_image}" for="image" />
                    <h:inputTextarea rows="4" cols="30" id="image" value="#{imagesController.selected.image}" title="#{bundle.CreateImagesTitle_image}" />
                    <h:outputLabel value="#{bundle.CreateImagesLabel_filename}" for="filename" />
                    <h:inputText id="filename" value="#{imagesController.selected.filename}" title="#{bundle.CreateImagesTitle_filename}" />
                </h:panelGrid>
                <br />
                <h:commandLink action="#{imagesController.create}" value="#{bundle.CreateImagesSaveLink}" />
                <br />
                <br />
                <h:commandLink action="#{imagesController.prepareList}" value="#{bundle.CreateImagesShowAllLink}" immediate="true"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.CreateImagesIndexLink}"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>

src/main/webapp/jsf/images/Edit.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.EditImagesTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.EditImagesLabel_id}" for="id" />
                    <h:inputText id="id" value="#{imagesController.selected.id}" title="#{bundle.EditImagesTitle_id}" required="true" requiredMessage="#{bundle.EditImagesRequiredMessage_id}"/>
                    <h:outputLabel value="#{bundle.EditImagesLabel_image}" for="image" />
                    <h:inputTextarea rows="4" cols="30" id="image" value="#{imagesController.selected.image}" title="#{bundle.EditImagesTitle_image}" />
                    <h:outputLabel value="#{bundle.EditImagesLabel_filename}" for="filename" />
                    <h:inputText id="filename" value="#{imagesController.selected.filename}" title="#{bundle.EditImagesTitle_filename}" />
                </h:panelGrid>
                <h:commandLink action="#{imagesController.update}" value="#{bundle.EditImagesSaveLink}"/>
                <br />
                <br />
                <h:link outcome="View" value="#{bundle.EditImagesViewLink}"/>
                <br />
                <h:commandLink action="#{imagesController.prepareList}" value="#{bundle.EditImagesShowAllLink}" immediate="true"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.EditImagesIndexLink}" />
            </h:form>
        </ui:define>
    </ui:composition>

</html>

src/main/webapp/jsf/images/List.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ListImagesTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:form styleClass="jsfcrud_list_form">
                <h:panelGroup id="messagePanel" layout="block">
                    <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
                </h:panelGroup>
                <h:outputText escape="false" value="#{bundle.ListImagesEmpty}" rendered="#{imagesController.items.rowCount == 0}"/>
                <h:panelGroup rendered="#{imagesController.items.rowCount > 0}">
                    <h:outputText value="#{imagesController.pagination.pageFirstItem + 1}..#{imagesController.pagination.pageLastItem + 1}/#{imagesController.pagination.itemsCount}"/>&nbsp;
                    <h:commandLink action="#{imagesController.previous}" value="#{bundle.Previous} #{imagesController.pagination.pageSize}" rendered="#{imagesController.pagination.hasPreviousPage}"/>&nbsp;
                    <h:commandLink action="#{imagesController.next}" value="#{bundle.Next} #{imagesController.pagination.pageSize}" rendered="#{imagesController.pagination.hasNextPage}"/>&nbsp;
                    <h:dataTable value="#{imagesController.items}" var="item" border="0" cellpadding="2" cellspacing="0" rowClasses="jsfcrud_odd_row,jsfcrud_even_row" rules="all" style="border:solid 1px">
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListImagesTitle_id}"/>
                            </f:facet>
                            <h:outputText value="#{item.id}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListImagesTitle_image}"/>
                            </f:facet>
                            <h:outputText value="#{item.image}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListImagesTitle_filename}"/>
                            </f:facet>
                            <h:outputText value="#{item.filename}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="&nbsp;"/>
                            </f:facet>
                            <h:commandLink action="#{imagesController.prepareView}" value="#{bundle.ListImagesViewLink}"/>
                            <h:outputText value=" "/>
                            <h:commandLink action="#{imagesController.prepareEdit}" value="#{bundle.ListImagesEditLink}"/>
                            <h:outputText value=" "/>
                            <h:commandLink action="#{imagesController.destroy}" value="#{bundle.ListImagesDestroyLink}"/>
                        </h:column>
                    </h:dataTable>
                </h:panelGroup>
                <br />
                <h:commandLink action="#{imagesController.prepareCreate}" value="#{bundle.ListImagesCreateLink}"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.ListImagesIndexLink}"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>

src/main/webapp/jsf/images/View.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ViewImagesTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputText value="#{bundle.ViewImagesLabel_id}"/>
                    <h:outputText value="#{imagesController.selected.id}" title="#{bundle.ViewImagesTitle_id}"/>
                    <h:outputText value="#{bundle.ViewImagesLabel_image}"/>
                    <h:outputText value="#{imagesController.selected.image}" title="#{bundle.ViewImagesTitle_image}"/>
                    <h:outputText value="#{bundle.ViewImagesLabel_filename}"/>
                    <h:outputText value="#{imagesController.selected.filename}" title="#{bundle.ViewImagesTitle_filename}"/>
                </h:panelGrid>
                <br />
                <h:commandLink action="#{imagesController.destroyAndView}" value="#{bundle.ViewImagesDestroyLink}"/>
                <br />
                <br />
                <h:link outcome="Edit" value="#{bundle.ViewImagesEditLink}"/>
                <br />
                <h:commandLink action="#{imagesController.prepareCreate}" value="#{bundle.ViewImagesCreateLink}" />
                <br />
                <h:commandLink action="#{imagesController.prepareList}" value="#{bundle.ViewImagesShowAllLink}"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.ViewImagesIndexLink}"/>

            </h:form>
        </ui:define>
    </ui:composition>

</html>